#!/bin/bash
# SPDX-Version: 3.0
# SPDX-CreationInfo: 2025-05-05; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-ExternalRef: GIT https://git.coresecret.dev/msw/CISS.debian.live.builder.git
# SPDX-FileContributor: WEIDNER, Marc S.; Centurion Intelligence Consulting Agency
# SPDX-FileCopyrightText: 2024-2025; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-FileType: SOURCE
# SPDX-License-Identifier: EUPL-1.2 OR LicenseRef-CCLA-1.0
# SPDX-LicenseComment: This file is part of the CISS.debian.installer.secure framework.
# SPDX-PackageName: CISS.debian.live.builder
# SPDX-Security-Contact: security@coresecret.eu

#######################################
# Trap function to be called on 'EXIT'.
# Globals:
#   VAR_DEBUG_TRACE
#   VAR_DEBUG_TRAP
# Arguments:
#   $1: "$?"
#######################################
trap_exit() {
  trap - DEBUG ERR EXIT INT
  declare -r var_trap_on_exit_code="$1"

  if [[ -n "${__preexec_invoke:-}" ]]; then
    debug_trap_logger "${var_trap_on_exit_code}" "${VAR_LAST_CMD}"
    unset __preexec_invoke
  fi

  if (( var_trap_on_exit_code == 0 )); then
    if [[ "${VAR_DEBUG_TRACE}" || "${VAR_DEBUG_TRAP}" ]]; then dump_vars_exiting; fi
    clean_up "${var_trap_on_exit_code}"
    print_scr_exit "${var_trap_on_exit_code}"
    exit "${var_trap_on_exit_code}"
  else
    clean_up "${var_trap_on_exit_code}"
    exit "${var_trap_on_exit_code}"
  fi
}

#######################################
# Print Success Message for Trap on 'EXIT' on 'stdout'.
# Globals:
#   LOG_DEBUG
#   LOG_TRACE
#   LOG_VAR
#   VAR_DEBUG_TRACE
#   VAR_DEBUG_TRAP
#   VAR_SCRIPT_SUCCESS
# Arguments:
#   $1: ${var_trap_on_exit_code} of trap_exit()
#######################################
print_scr_exit() {
  declare -r var_print_scr_exit_code="$1"
  if (( var_print_scr_exit_code == 0 )); then
    if [[ "${VAR_SCRIPT_SUCCESS}" == true ]]; then
      printf "\n"
      printf "\e[92m✅ CISS.debian.installer Script successful. \e[0m\n"
      printf "\e[92m✅ Exited with Status : %s \e[0m\n" "${var_print_scr_exit_code}"
      printf "\n"
      if [[ "${VAR_DEBUG_TRACE}" || "${VAR_DEBUG_TRAP}" ]]; then
        printf "\e[92m✅ Vars Dump saved at : %s \e[0m\n" "${LOG_VAR}"
        printf "\e[92m✅                  cat %s \e[0m\n" "${LOG_VAR}"
      fi
      if "${VAR_DEBUG_TRAP}"; then
        printf "\e[92m✅ DEBUG Log saved at : %s \e[0m\n" "${LOG_DEBUG}"
        printf "\e[92m✅                  cat %s \e[0m\n" "${LOG_DEBUG}"
      fi
      if "${VAR_DEBUG_TRACE}"; then
        printf "\e[92m✅ TRACE Log saved at : %s \e[0m\n" "${LOG_TRACE}"
        printf "\e[92m✅                  cat %s \e[0m\n" "${LOG_TRACE}"
      fi
      printf "\n"
      printf "\e[95m💷 Please consider donating to my work at: \e[0m\n"
      printf "\e[95m🔗 https://coresecret.eu/spenden/          \e[0m\n"
      printf "\n"
    fi
  fi
}
# vim: number et ts=2 sw=2 sts=2 ai tw=128 ft=sh
